#include <stdio.h>
#include <math.h>
#include "S.h"

void pcdists(dist,nn,dcrit,eps,bigd)
long *nn;
double *dist, *dcrit, *eps, *bigd;
{
double maxd,mind,sum,big=*bigd,dki,dkj,adj;
long i,j,k,ki,kj,pos,n=*nn,ndist,nbig,nbigold,nloop,count;
ndist = n*(n-1)/2;
nbig = 0;
for (i=0;i<ndist;i++)
if (dist[i]>*dcrit-*eps) 
{
dist[i] =  -1;
nbig += 1;
}
nloop=0;
fprintf(stdout, "Loop %2d : Number of distances > critical distance %5d \n", nloop, nbig);  
fflush(stdout); 

while (nbig>0)

{
nbigold=nbig;
nloop += 1;

maxd = 0.0;
mind = 1e9;

for (j=1;j<n;j++)
for (i=0;i<j;i++) {
pos = n*i-i*(i+1)/2+j-i-1;
if(dist[pos] < 0) {
sum = 0.0;
count = 0;

for (k=0;k<n;k++) {
if ((k!=i)&(k!=j))
{
if (k>i)
ki = n*i-i*(i+1)/2+k-i-1;
else 
ki = n*k-k*(k+1)/2+i-k-1;
if (k>j)
kj = n*j-j*(j+1)/2+k-j-1;
else 
kj = n*k-k*(k+1)/2+j-k-1;
dki=dist[ki];
dkj=dist[kj];
if ((dki>=0) & (dkj>=0) & (dki<big) & (dkj<big))
{
sum += dki+dkj;
count += 1;
}
}
}
if (count>0) {
dist[pos] = sum/count + big;
if (dist[pos]>maxd) maxd = dist[pos];
if (dist[pos]<mind) mind = dist[pos];
}
}
}

fprintf(stdout, "Max and min distances %7.2f %7.2f \n", maxd-big, mind-big);  
fflush(stdout); 


nbig = 0;
for (i=0;i<ndist;i++)
if (dist[i]<0) nbig += 1;
fprintf(stdout, "Loop %2d : Number of distances > critical distance %5d \n", nloop, nbig);
fflush(stdout); 
if (nbigold==nbig) {
nbig=0;
fprintf(stdout, "Data disconnected \n");  
fflush(stdout); 
}

if (nbig>0) adj=1.0;
else adj=0.5;

for (i=0;i<ndist;i++)
{
if (dist[i] > big)
 dist[i] = dist[i] - big;
}


}
}

